#include "Tcp_Server.h"

#include <iostream>

using namespace std;

Tcp_Server::Tcp_Server()
{
	this->ptr_Special = NULL; //const_cast<CDockWidget*>(parent);
	connect( &server, SIGNAL(newConnection()),this, SLOT(acceptConnection()) );
	server.listen(QHostAddress::Any, CHALLENGE_PORT);
	if (DEBUGMODE) printf("\n[DEBUG] Create Server - Listen on PORT: %d", CHALLENGE_PORT);
}

Tcp_Server::~Tcp_Server(void)
{
	server.close();
	client->close();
	if (DEBUGMODE) printf("\n[DEBUG] CLOSE SERVER %s! \n[DEBUG] CLOSE CLIENT %s!", server.objectName(), client->objectName());
}

void Tcp_Server::acceptConnection()
{
	client = server.nextPendingConnection();
	connect( client, SIGNAL(readyRead()), this, SLOT(startRead()) );
	if (DEBUGMODE) printf("\n\n[DEBUG] Connection accepted!");
}

void Tcp_Server::startRead()
{
	char buffer[MAX_BYTES] = {0};
	client->read( buffer, client->bytesAvailable() );
	if (DEBUGMODE) printf("\n[DEBUG] Buffer is: %s\n", buffer);
	QString recvdBuf(buffer);
	this->ptr_Special->parse_DEBUG_Msg(&recvdBuf);
}
// EOF
